ru.bitel.bgbilling.modules.subscription.server.bean

## Class SubscriptionDao

- java.lang.Object
- - ru.bitel.common.dao.AbstarctDaoConstant
  - - ru.bitel.common.dao.AbstractDao<B>
    - - ru.bitel.common.dao.AbstractIdDao<Subscription>
      - - ru.bitel.bgbilling.modules.subscription.server.bean.SubscriptionDao

- All Implemented Interfaces:
    java.lang.AutoCloseable

      public class SubscriptionDao
      extends ru.bitel.common.dao.AbstractIdDao<Subscription>

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ru.bitel.common.dao.AbstractDao

      `ru.bitel.common.dao.AbstractDao.ResultSetIterator`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `userId`

    - ### Fields inherited from class ru.bitel.common.dao.AbstractDao

      `cacheFilter, cacheJoin, cacheOrderBy, cachePaged, cachePS, cacheWhat, con, getByIdPS, mid, moduleId, orderByPattern, tableName`

    - ### Fields inherited from class ru.bitel.common.dao.AbstarctDaoConstant

      `ERROR, SQL_CALC_FOUND_ROWS, SQL_DELETE, SQL_DISTINCT, SQL_EQ, SQL_EQCS, SQL_FROM, SQL_GROUP, SQL_IN, SQL_INSERT, SQL_LIMIT, SQL_ON_DUPLICATE_KEY_UPDATE, SQL_ORDER, SQL_SELECT, SQL_SET, SQL_UPDATE, SQL_VALUES, SQL_WHERE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SubscriptionDao(java.sql.Connection con, int moduleId, int userId)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDetail(CostSumTime costSumTime, int registrationPeriodId)` Добавление записи в таблицу детализации наработки
    `java.util.List<CostSumTime>` | `getAmountDetail(int contractId, PeriodWithTime period)`
    `protected Subscription` | `getFromRS(java.sql.ResultSet rs)`
    `java.util.List<Subscription>` | `list(int contractId)`
    `protected void` | `updateImpl(Subscription subscription)`
    `void` | `updateRegistrationPeriodId(int subscriptionId, int registrationPeriodId)`
    `void` | `updateSubscriptionJobId(int subscriptionId, long subscriptionJobId)`

    - ### Methods inherited from class ru.bitel.common.dao.AbstractIdDao

      `delete, get, getAndDelete, getAndUpdate`

    - ### Methods inherited from class ru.bitel.common.dao.AbstractDao

      `close, delete, deleteImpl, eq, get, getById, getImpl, getListFromRS, getPeriod, getSQLOrder, getTableName, list, list, listImpl, listImpl, listImplPS, listImplPS, processException, recycle, setStatementParam, update`

    - ### Methods inherited from class ru.bitel.common.dao.AbstarctDaoConstant

      `getSQLOrder`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### userId

          protected final int userId

  - ### Constructor Detail

    - #### SubscriptionDao

          public SubscriptionDao(java.sql.Connection con,
                                 int moduleId,
                                 int userId)

      Parameters:
        `con` -
        `moduleId` -
        `userId` -

  - ### Method Detail

    - #### getFromRS

          protected Subscription getFromRS(java.sql.ResultSet rs)
                                    throws java.sql.SQLException,
                                           ru.bitel.bgbilling.common.BGException

      Specified by:
        `getFromRS` in class `ru.bitel.common.dao.AbstractDao<Subscription>`
      Throws:
        `java.sql.SQLException`
        `ru.bitel.bgbilling.common.BGException`

    - #### updateImpl

          protected void updateImpl(Subscription subscription)
                             throws ru.bitel.bgbilling.common.BGException,
                                    java.sql.SQLException

      Specified by:
        `updateImpl` in class `ru.bitel.common.dao.AbstractDao<Subscription>`
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.sql.SQLException`

    - #### updateRegistrationPeriodId

          public void updateRegistrationPeriodId(int subscriptionId,
                                                 int registrationPeriodId)
                                          throws ru.bitel.bgbilling.common.BGException

      Parameters:
        `subscriptionId` -
        `registrationPeriodId` -
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### updateSubscriptionJobId

          public void updateSubscriptionJobId(int subscriptionId,
                                              long subscriptionJobId)
                                       throws ru.bitel.bgbilling.common.BGException

      Parameters:
        `subscriptionId` -
        `subscriptionJobId` -
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### list

          public java.util.List<Subscription> list(int contractId)
                                            throws ru.bitel.bgbilling.common.BGException

      Parameters:
        `contractId` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### addDetail

          public void addDetail(CostSumTime costSumTime,
                                int registrationPeriodId)
                         throws ru.bitel.bgbilling.common.BGException

      Добавление записи в таблицу детализации наработки
      Parameters:
        `contractId` - код договора
        `serviceId` - код услуги
        `summ` - сумма наработки
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getAmountDetail

          public java.util.List<CostSumTime> getAmountDetail(int contractId,
                                                             PeriodWithTime period)
                                                      throws ru.bitel.bgbilling.common.BGException

      Parameters:
        `contractId` -
        `period` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`